﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using BTCArbCore;
using BTCArbCore.Exchanges;

namespace btcarbdemtgcalc
{
  public partial class Form1 : Form
  {
    const decimal DE_FEE_PERCENT = 0.005M; //0.5%
    const decimal BANK_FIX_FEE = 0.2M; //0.2 EUR

    const decimal BANK_FROM_MTG_FEE_MIN_EUR = 1.3M; // MIN 1,3EUR or 1%
    const decimal BANK_FROM_MTG_FEE_PERCENT = 0.01M; //1%
    const decimal MTGOXFEE = 0.006M; // 0.6 %



    public Form1()
    {
      InitializeComponent();
    }

    private void btnCalc_Click(object sender, EventArgs e)
    {
      decimal dePrice;
      decimal mtPrice;
      decimal amount;
      decimal totalPay;
      decimal totalReceive;

      decimal deReceive;

      decimal mtgoxReceive;
      decimal mtgoxFee;
      decimal mtgoxBankFee;

      dePrice = decimal.Parse(txbDEPrice.Text);
      mtPrice = decimal.Parse(txbMtGoxPrice.Text);
      amount = decimal.Parse(txbAmount.Text);
      
      decimal volume = (dePrice * amount);
      decimal volumeFee = volume * DE_FEE_PERCENT;
      totalPay = volume - volumeFee;
      totalPay = Math.Floor(totalPay * 100) / 100M;
      totalPay += BANK_FIX_FEE;

      decimal tmpFeeReceive = amount * (DE_FEE_PERCENT * 2);
      deReceive = amount - tmpFeeReceive;

      txbTotalPay.Text = totalPay.ToString();
      txbDEReceive.Text = deReceive.ToString();
      
      mtgoxReceive = deReceive * mtPrice;
      mtgoxFee = mtgoxReceive * MTGOXFEE;

      mtgoxBankFee = mtgoxReceive * BANK_FROM_MTG_FEE_PERCENT;
      
      if (mtgoxBankFee < BANK_FROM_MTG_FEE_MIN_EUR) //1% or minimal 1.3EUR
        mtgoxBankFee = BANK_FROM_MTG_FEE_MIN_EUR;

      mtgoxBankFee += BANK_FIX_FEE;
      
      txbMtGoxRec.Text = mtgoxReceive.ToString();
      txbMtGoxFee.Text = mtgoxFee.ToString();

      txbBankFee.Text = mtgoxBankFee.ToString();

      totalReceive = mtgoxReceive - mtgoxFee;

      if (chbIncludeMtGoxBankFee.Checked)
        totalReceive -= mtgoxBankFee;

      txbTotalReceive.Text = totalReceive.ToString();

      txbProfit.Text = (totalReceive - totalPay).ToString();
    }

    private void button1_Click(object sender, EventArgs e)
    {
      txbAmount.BackColor = Color.Orange;
      txbDEPrice.BackColor = Color.Orange;
      txbMtGoxPrice.BackColor = Color.Orange;

      txbAmount.Refresh();
      txbDEPrice.Refresh();
      txbMtGoxPrice.Refresh();

      var de = new BitcoinDE();
      var gox = new MtGox();

      var pricesDe = de.GetPrices();
      var pricesGox = gox.GetPrices();

      var lastPriceDe = pricesDe.Where(x => x.Type == MarketType.Sell).First();
      var lastPriceGox = pricesGox.Where(x => x.Type == MarketType.Buy).First();

      txbAmount.Text = lastPriceDe.MinBuy.ToString();
      txbDEPrice.Text = lastPriceDe.Price.ToString();
      txbMtGoxPrice.Text = lastPriceGox.Price.ToString();

      txbAmount.BackColor = SystemColors.Window;
      txbDEPrice.BackColor = SystemColors.Window;
      txbMtGoxPrice.BackColor = SystemColors.Window;
    }
  }
}
